<?php
/***************************************************************
 *	Copyright notice
 *
 *	(c) 2006 Fabien Udriot <fabien.udriot@ecodev.ch>
 *	All rights reserved
 *
 *	This script is part of the TYPO3 project. The TYPO3 project is
 *	free software; you can redistribute it and/or modify
 *	it under the terms of the GNU General Public License as published by
 *	the Free Software Foundation; either version 2 of the License, or
 *	(at your option) any later version.
 *
 *	The GNU General Public License can be found at
 *	http://www.gnu.org/copyleft/gpl.html.
 *
 *	This script is distributed in the hope that it will be useful,
 *	but WITHOUT ANY WARRANTY; without even the implied warranty of
 *	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.	See the
 *	GNU General Public License for more details.
 *
 *	This copyright notice MUST APPEAR in all copies of the script!
 ***************************************************************/
/**
 * Plugin 'Photo gallery express' for the 'eco_gal' extension.
 *
 * @author	Fabien Udriot <fabien.udriot@ecodev.ch>
 */

$extPath = t3lib_extMgm::siteRelPath('eco_gal'); // $GLOBALS['TYPO3_LOADED_EXT']['eco_gal']

require_once(PATH_tslib.'class.tslib_pibase.php');
require_once($extPath.'share/lib/class.tx_damSelector.php');
require_once($extPath.'alb1/lib/class.appManager.php');
require_once($extPath.'alb1/lib/class.dataManager.php'); //include useful staff for db manager
require_once(t3lib_extMgm::extPath('jquery')."class.tx_jquery.php");

require_once(t3lib_extMgm::siteRelPath('dam').'lib/class.tx_dam_querygen.php');
// init the global $LANG useful for tx_damSelector when no backendlogin
require_once('typo3/sysext/lang/lang.php');
require_once(PATH_t3lib.'class.t3lib_befunc.php');

if($LANG == null){
	global $LANG;
	$LANG = t3lib_div::makeInstance('language');
}

class tx_ecogal_alb1 extends tslib_pibase {
	var $prefixId = 'tx_ecogal_alb1';		// Same as class name
	var $scriptRelPath = 'alb1/class.tx_ecogal_alb1.php';	// Path to this script relative to the extension dir.
	var $extKey = 'eco_gal';	// The extension key.
	var $pi_checkCHash = TRUE;
	var $xtpl;
	var $sel;
	var $data;
	var $flexdata;
	var $cssPly1;
	
	/**
	 * The main method of the PlugIn
	 *
	 * @param	string		$content: The PlugIn content
	 * @param	array		$conf: The PlugIn configuration
	 * @return	The content that is displayed on the website
	 */
	function main($content,$conf){
		/* *********************************/
		/* init some objects & parameters  */
		/* *********************************/
		$fe =& $GLOBALS['TSFE']; //return tslib_fe
		$user =& $fe->fe_user; //return tslib_feUserAuth
		$div = t3lib_div::makeInstance('t3lib_div');
		$this->pi_initPIflexForm();
		$fe->set_no_cache(); //necessary... since it changes all the time
		$this->sel = new tx_damSelector();
		$this->data = new tx_dataManager_alb1();
		$this->flexdata = t3lib_div::xml2array($this->cObj->data['alb1_flexform']);
		
		/* *********************************/
		/* init some variables			   */
		/* *********************************/
		//init template + other stuff
		$app = new tx_appManager_alb1($this);
		$this->cssPly1 = new tx_xtemplate(t3lib_extMgm::siteRelPath($this->extKey).'ply1/tpl/ecogal_ply1_css.tpl');
		$this->xtpl = new tx_xtemplate(t3lib_extMgm::siteRelPath($this->extKey).'alb1/tpl/ecogal_alb1.tpl');
		$interval = $this->pi_getFFvalue($this->flexdata,'interval','sPrefAlb');
		if($interval == ''){
			$interval = 1;
		}
		$this->xtpl->assign('TT_CONTENT',$this->cObj->data['uid']);
		$this->xtpl->assign('SLIDE_WIDTH',$this->pi_getFFvalue($this->flexdata,'gallerySize','sPref'));
		$this->xtpl->assign('THUMB_SIZE',$this->pi_getFFvalue($this->flexdata,'thumbnailSize','sPref'));
		$this->xtpl->assign('PATH',t3lib_extMgm::siteRelPath($this->extKey));
		$this->xtpl->assign('LOADING_URL',t3lib_extMgm::siteRelPath($this->extKey).'share/img/');
		$this->xtpl->assign('ORDER',$this->pi_getFFvalue($this->flexdata,'defaultOrder','sPref'));
		$this->xtpl->assign('INTERVAL',$interval * 1000);
		$this->xtpl->assign('CROSS_FADE',$this->pi_getFFvalue($this->flexdata,'isCrossFade','sPrefAlb'));
		if($this->pi_getFFvalue($this->flexdata,'isFrame','sPrefAlb') == 1){
			$this->xtpl->assign('IS_FRAME','img-shadow');
		}

		/* *********************/
		/* handle the css + js */
		/* *********************/
		tx_jquery::includeLib(); //jquery lib
		$extPath = t3lib_extMgm::extRelPath('eco_gal');
		$fe->additionalHeaderData['eco_alb1_css_1'] = '<link rel="stylesheet" href="'.$extPath.'share/css/eco_gal.css" type="text/css" media="screen" />';
		$fe->additionalHeaderData['eco_alb1_css_2'] = '<link rel="stylesheet" href="'.$extPath.'alb1/css/albumView.css" type="text/css" media="screen" />';
		$app->initCssPly1();
		$fe->additionalHeaderData['eco_alb1_css_4'] = $this->cssPly1->out('css');
		$fe->additionalHeaderData['eco_alb1_js_1'] = '<script type="text/javascript" src="'.$extPath.'alb1/js/albumView.js"></script>';
		$fe->additionalHeaderData['eco_alb1_js_2'] = '<script type="text/javascript" src="'.$extPath.'alb1/js/albumCom.js"></script>';
		$fe->additionalHeaderData['eco_alb1_js_3'] = '<script type="text/javascript" src="'.$extPath.'share/js/urlparser.js"></script>';
		$fe->additionalHeaderData['eco_alb1_js_4'] = '<script type="text/javascript" src="'.$extPath.'ply1/js/playerView.js"></script>';

		/* *****************/
		/* handle the html */
		/* *****************/
		if($this->pi_getFFvalue($this->flexdata,'selections','sSource') != ''){
			$app->initAlbumView();
		}
		else{
			die('PLUGIN ECO_GAL ERROR : no album source defined for <b>content element '.$this->cObj->data['uid'].'</b> on page '.$this->cObj->data['pid']);
		}
		
		$this->xtpl->parse('viewAlbum');
		return $this->pi_wrapInBaseClass($this->xtpl->out('viewAlbum'));
	}
}

if (defined('TYPO3_MODE') && $TYPO3_CONF_VARS[TYPO3_MODE]['XCLASS']['ext/eco_gal/alb1/class.tx_ecogal_alb1.php'])	{
	include_once($TYPO3_CONF_VARS[TYPO3_MODE]['XCLASS']['ext/eco_gal/alb1/class.tx_ecogal_alb1.php']);
}
?>
