<?php
/***************************************************************
 *	Copyright notice
 *
 *	(c) 2006 Fabien Udriot <fabien.udriot@ecodev.ch>
 *	All rights reserved
 *
 *	This script is part of the TYPO3 project. The TYPO3 project is
 *	free software; you can redistribute it and/or modify
 *	it under the terms of the GNU General Public License as published by
 *	the Free Software Foundation; either version 2 of the License, or
 *	(at your option) any later version.
 *
 *	The GNU General Public License can be found at
 *	http://www.gnu.org/copyleft/gpl.html.
 *
 *	This script is distributed in the hope that it will be useful,
 *	but WITHOUT ANY WARRANTY; without even the implied warranty of
 *	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.	See the
 *	GNU General Public License for more details.
 *
 *	This copyright notice MUST APPEAR in all copies of the script!
 ***************************************************************/
/**
 * Plugin 'Photo gallery express' for the 'eco_gal' extension.
 *
 * @author	Fabien Udriot <fabien.udriot@ecodev.ch>
 */

class tx_appManager_alb1{

	/* object proprieties  */
	private $self;
	private $cObj;
	private $xtpl;
	private $data;
	private $flexdata;
	private $cssPly1; //ply1 css put in the header

	/***********************************************************
	 * CONSTRUCTOR PHP 5, pass objects by reference
	 ***********************************************************/
	function __construct(&$self){
		$this->cObj =& $self->cObj;
		$this->self =& $self;
		$this->xtpl =& $self->xtpl;
		$this->sel =& $self->sel;
		$this->data =& $self->data;
		$this->flexdata =& $self->flexdata;
		$this->cssPly1 =& $self->cssPly1;
	}

	/***********************************************************
	 * INIT ALBUM VIEW
	 ***********************************************************/
	function initAlbumView(){
		//get some values
		$thumbnailSize = $this->getFFvalue('thumbnailSize','sPrefAlb');
		$colNumber = $this->getFFvalue('colNumber','sPrefAlb');
		$this->xtpl->assign('WIDTH',$this->getFFvalue('gallerySize','sPrefAlb'));
		$this->xtpl->assign('WIDTH_COL',100/$colNumber);
		$interval = $this->getFFvalue('interval','sPrefAlb');

		$loop = 0;
		$selections = explode(',',$this->getFFvalue('selections','sSource'));
		if($this->getFFvalue('limit','sPref') != 0){
			$this->sel->max = $this->getFFvalue('limit','sPref');
		}
		$this->sel->sort = 'uid DESC';
		foreach($selections as $selection){
			if($this->data->checkSelection($selection)){
				$comma = '';
				$thumbnails = '';

				$images = $this->sel->getMedias($selection);
				foreach($images as $image){
					//reszie the thumbnails
					$configThumbnail['file'] = $image['file_path'].$image['file_name'];
					//SECURITY : CHECK IF THE FILE EXIST
					if(is_file($configThumbnail['file']) && substr($image['file_name'],0,1) != '.'){ //handle hidden file
						$configThumbnail['altText'] = '';
						$configThumbnail['file.']['height'] = $thumbnailSize;
						$htmlThumbnail = $this->cObj->IMAGE($configThumbnail);

						$thumbnails .= $comma.'\''.$this->_getImagePath($htmlThumbnail).'\'';
						if($comma == ''){
							$comma = ',';
							$thumbnail = $this->_getImagePath($htmlThumbnail);
						}
					}
					else{
						$this->data->deleteMedia($image['uid']);
						//delete hidden .file that are created by the OS for thumbnails
						if(is_file($configThumbnail['file']) && substr($image['file_name'],0,1) == '.' && mime_content_type($configThumbnail['file']) == 'image/jpeg'){
							unlink($configThumbnail['file']);
						}
					}
				}
				$this->xtpl->assign('NUM',$loop);
				$this->xtpl->assign('RAND',rand(2000, $interval * 1000));
				$this->xtpl->assign('UID',$selection);
				$this->xtpl->assign('THUMBNAIL',$thumbnail);
				$this->xtpl->assign('THUMBNAILS',$thumbnails);
				$loop ++;

				$this->xtpl->assign('TITLE',htmlspecialchars($this->data->getSelectionTitle($selection)));

				$this->xtpl->assign('STYLE','center');
				$this->xtpl->parse('viewAlbum.row.col');
				if($loop % $colNumber == 0){
					$this->xtpl->parse('viewAlbum.row');
				}
			}
		}

		$this->xtpl->assign('GAL_NUM',$loop);
		if($loop % $colNumber != 0){ //reparse if it is even
			$this->xtpl->parse('viewAlbum.row');
		}
	}

	/***********************************************************
	 * INIT THE JAVASCRIPT + CSS FOR PLAYER 1
	 ***********************************************************/
	function initCssPly1(){
		$flexdata =& $this->flexdata;
		$imageHeight = $this->getFFvalue('imageSize','sPref');
		$thumbnailHeight = $this->getFFvalue('thumbnailSize','sPref');
		$gallerySize = $this->getFFvalue('gallerySize','sPref');
		$bgColor = $this->getFFvalue('bgColor','sPref');

		if($bgColor == null) $bgColor = '#FFF';
		switch($imageHeight){
			case 300:
				$imgHeight = 300;
				break;
			case 350:
				$imgHeight = 340;
				break;
			case 400:
				$imgHeight = 390;
				break;
			case 450:
				$imgHeight = 430;
				break;
			case 500:
				$imgHeight = 470;
				break;
			case 550:
				$imgHeight = 510;
				break;
			case 600:
				$imgHeight = 560;
				break;
		}

		$this->cssPly1->assign('THUMBNAIL_HEIGHT', $thumbnailHeight + 8);
		$this->cssPly1->assign('IMAGE_HEIGHT', $imgHeight);
		$this->cssPly1->assign('ARROW_HEIGHT', $thumbnailHeight);//pixel
		$this->cssPly1->assign('ARROW_TOP', $thumbnailHeight / 10);//pixel
		$this->cssPly1->assign('GALLERY_SIZE', $gallerySize);//pixel the height of the gallery
		$this->cssPly1->assign('WAIT_MSG_TOP', $imgHeight / 2);//pixel the height of the wait msg

		//left : 150px; -> 400 ($gallerySize)
		//left : 200px; -> 500  ($gallerySize)
		//left : 250px; -> 600 ($gallerySize)
		$this->cssPly1->assign('WAIT_MSG_LEFT', ($gallerySize - 100) / 2);//pixel the height of the wait msg
		$this->cssPly1->assign('BG_COLOR', $bgColor);
		$this->cssPly1->assign('COLOR_SELECTED', $this->getFFvalue('colorSelectedImg','sPref'));
		$this->cssPly1->parse('css');
	}

	/***********************************************************
	 * RETURN THE VALUE OF THE ATTRIBUTE SRC FROM A IMG
	 ***********************************************************/
	function _getImagePath($htmlImage){
		$substr = substr($htmlImage, 10, 100);
		$stop = strpos($substr, '"');
		return substr($substr, 0, $stop);
	}

	/**
	 * extract a flexform's value from a specific sheet
	 */
	function getFFValue($field,$sheet){
		return $this->self->pi_getFFvalue($this->flexdata,$field,$sheet);
	}
}
?>
