<?php
/***************************************************************
*	Copyright notice
*
*	(c) 2006 Fabien Udriot <fabien.udriot@ecodev.ch>
*	All rights reserved
*
*	This script is part of the TYPO3 project. The TYPO3 project is
*	free software; you can redistribute it and/or modify
*	it under the terms of the GNU General Public License as published by
*	the Free Software Foundation; either version 2 of the License, or
*	(at your option) any later version.
*
*	The GNU General Public License can be found at
*	http://www.gnu.org/copyleft/gpl.html.
*
*	This script is distributed in the hope that it will be useful,
*	but WITHOUT ANY WARRANTY; without even the implied warranty of
*	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.	See the
*	GNU General Public License for more details.
*
*	This copyright notice MUST APPEAR in all copies of the script!
***************************************************************/
/**
 * Plugin 'Photo gallery express' for the 'eco_gal' extension.
 *
 * @author	Fabien Udriot <fabien.udriot@ecodev.ch>
 */

$extPath = t3lib_extMgm::siteRelPath('eco_gal'); // $GLOBALS['TYPO3_LOADED_EXT']['eco_gal']

require_once(PATH_tslib.'class.tslib_pibase.php');
require_once($extPath.'pi1/lib/class.tx_util.php');	 //include usuful staff
require_once($extPath.'pi1/lib/class.appManager.php'); 
require_once($extPath.'pi1/lib/class.dataManager.php'); //include useful staff for db manager
require_once($extPath.'pi1/lib/class.jcManager.php'); 


class tx_ecogal_pi1 extends tslib_pibase {
	var $prefixId = 'tx_ecogal_pi1';		// Same as class name
	var $scriptRelPath = 'pi1/class.tx_ecogal_pi1.php';	// Path to this script relative to the extension dir.
	var $extKey = 'eco_gal';	// The extension key.
	var $pi_checkCHash = TRUE;
	var $tplPath;
	/**
	 * The main method of the PlugIn
	 *
	 * @param	string		$content: The PlugIn content
	 * @param	array		$conf: The PlugIn configuration
	 * @return	The content that is displayed on the website
	 */
	function main($content,$conf)	{
	
		/* *********************************/
		/* init some objects & parameters	*/
		/* *********************************/
		$cObj = $this->cObj; //return tslib_cObj
		$db = $GLOBALS['TYPO3_DB']; //return t3lib_DB
		$fe = $GLOBALS['TSFE']; //return tslib_fe
		$user = $fe->fe_user; //return tslib_feUserAuth 
		$extMgm = new t3lib_extMgm();
		$div = new t3lib_div();
		$this->pi_initPIflexForm();
		$util = new tx_util_ecogal();		
		$this->conf=$conf;
		$flexdata = $cObj->data['pi_flexform'];
		$fe->set_no_cache(); //necessary... since it changes all the time
		
		/* *********************************/
		/* handle the language						 */
		/* *********************************/
		$configLang = strtoupper($fe->config["config"]["language"]); //given by the typoscript config.lang = fr
		$pluginLang = $cObj->data['tx_ecogal_lang'];
		
		//$pluginLang = 0 -> English	 # value get from the flexform plugin
		//$pluginLang = 1 -> French
		//$pluginLang = 2 -> German
	 	//$div->debug($GLOBALS['_POST']);
	 	
		//in case there is no typoscript config.language defined...
		if($configLang == null){
			switch($pluginLang){
				case 0 :
					$this->LLkey = 'en';
					break;
				case 1 :
					$this->LLkey = 'fr';
					break;
				case 2 :
					$this->LLkey = 'de';
					break;
				case 3 :
					$this->LLkey = 'it';
					break;
				default :
					$this->LLkey = 'default';
					break;
			}
		}
		$this->pi_loadLL();
		$feLang = $util->getFFLang($pluginLang,$configLang);
		/* *********************************/
		/* init some variables						 */
		/* *********************************/
		$extPath = $extMgm->siteRelPath($this->extKey).'pi1/';
		$tplPath = $extPath.'tpl/';
		$this->tplPath = $tplPath;
		$url = $this->pi_getPageLink($fe->id);
		
		//init template + other stuff
		$xtpl = new tx_xtemplate($tplPath.'gallery.tpl');
		$data = new tx_dataManager_ecogal($this,$cObj,$util,$user,$db);
		$app = new tx_appManager_ecogal($this,$cObj,$div,$xtpl,$util,$user,$db,$fe,$data,$feLang);
		$jc = new tx_jcManager_ecogal($this,$cObj,$div);
		
		if($div->GPvar('display') == 'player')
			$display = 1; //player
		else
			$display =	$cObj->data['tx_ecogal_display'];
			
		//display == 0 -> album
		//display == 1 -> the player
		//display == 2 -> the last import
		/* ********************/
		/* handle the session */
		/* ********************/
		if($user->getKey('ses','category') == '') //the first time the value is null, so set a value
			$user->setKey('ses','category','all');
		if($div->GPvar('category') != null) //true when the user give a $_GET value
			$user->setKey('ses','category',$div->GPvar('category'));
			
		if($user->getKey('ses','album') == '') //the first time the value is null, so set a value
			$user->setKey('ses','album','all');
		if($div->GPvar('album') != null) //true when the user give a $_GET value
			$user->setKey('ses','album',$div->GPvar('album'));

		if($user->getKey('ses','sort') == '') //the first time the value is null, so set a value
			$user->setKey('ses','sort','DESC');
		if($div->GPvar('sort') != null) //true when the user give a $_GET value
			$user->setKey('ses','sort',$div->GPvar('sort'));

		if($div->GPvar('comeFromLastImport') == 'true'){
			$user->setKey('ses','category',$div->GPvar('category'));
			$user->setKey('ses','album',$div->GPvar('album'));
		}
		/* *****************/
		/* handle the html */
		/* *****************/
		//$this->pi_linkToPage('test1',$fe->id,'_top',array('category'=>'all'));
		
		/* handle global css + js */		
		$app->addCss('util.css');
		$app->addJs('util.js');
		/* handle global xtemplate variables */
		$xtpl->assign('PATH', $extPath);
		$xtpl->assign('PATH_IMAGE_STATIC', $extPath.'images/');
		$xtpl->assign('URL', $url);
		
		switch($display){
			case 0 :
				/* handle the css + js */
				$app->addJs('albumView.js');
				$user->setKey('ses','isAlbumDisplayActivated','true');
				//get the datas
				if ($this->pi_getFFvalue($flexdata,'displayType','sAlbumPref') == 0){
					$records = $data->getAlbums();
					$recordType = 'album';
				}
				else{
					$records = $data->getCategories();
					$recordType = 'category';
				}
				$app->initAlbumView($records,$flexdata,$recordType);
				$xtpl->parse('viewAlbum');
				$content = $xtpl->out('viewAlbum');
				break;
			case 1 :
				/* *********************/
				/* write css + js file */
				/* *********************/
				if($jc->isConfigChanged($flexdata)){
					if(!$jc->changeConfig($flexdata))
						return '<b>FILE PERMISSION ERROR</b> : make sure '.$extMgm->siteRelPath('eco_gal').'pi1/css + js + config are writable';
				}
				/* handle css + js */
				$app->addCss($cObj->data['uid'].'_playerView.css');
				$app->addJs($cObj->data['uid'].'_playerView.js');
				
				//init the page go back 
				if($div->GPvar('goBack'))
					$app->initGoBack();
					
				//init the html select
				$categories = $data->getCategories();
				$albums = $data->getAlbums();
				$xtpl->assign('URL',$this->pi_getPageLink($fe->id));
				$data->isCategoryVisible($flexdata);
				if($data->isCategoryVisible($flexdata) == 1)
					$app->initCategorySelect($categories); //init the category select
				if($data->isAlbumVisible($flexdata) == 1)
					$app->initAlbumSelect($albums); //init the category select
				if($data->isSortingVisible($flexdata) == 1)
					$app->initSortSelect(); //init the category select
				
				//init the gallery
				$images =	$data->getImages();
				if($div->GPvar('imageId')) //it is not null
					$firstImage = $data->getImage($div->GPvar('imageId'));
				else
					$firstImage = $images[0];
				$app->initThumbnailImage($images,$flexdata); //set the image thumbnail
				$app->initCaptionImage($images);//set the image caption
				$app->initFirstImage($firstImage,$flexdata);//init the first default image		

				//display a return
				if($user->getKey('ses','isAlbumDisplayActivated') == 'true' && $cObj->data['tx_ecogal_display'] != 1){
					$xtpl->assign('GOBACK_ALBUM',$this->pi_getLL('goBack_album'));
					$xtpl->parse('viewPlayer.goBackAlbum');
				}
				$xtpl->parse('viewPlayer');
				$content = $xtpl->out('viewPlayer');
				break;
			case 2 :
				$categoryId = $this->pi_getFFvalue($flexdata,'categoryId','sLastImportPref');
				$albumId = $this->pi_getFFvalue($flexdata,'albumId','sLastImportPref');
				$imageNum = $this->pi_getFFvalue($flexdata,'imageNum','sLastImportPref');
				if($categoryId == '') $categoryId = 0;
				if($albumId == '') $albumId = 0;
				
				if(!$data->existsCategory($categoryId)){
					$content = "<b>PLUGIN ERROR</b> : the category id \"$categoryId\" doesn't exist. Please specify a correct category Id in the plugin options, section \"last import preferences\"";
				}
				else if(!$data->existsAlbum($albumId)){
					$content = "<b>PLUGIN ERROR</b> : the given album id \"$albumId\" doesn't exist. Please specify a correct album Id in the plugin options, section \"last import preferences\"";
				}
				else{
					$images =	$data->getLastImportImages($categoryId,$albumId,$imageNum);
					$categoryId = $this->pi_getFFvalue($flexdata,'categoryId','sLastImportPref');
					$category = $data->getCategoryName($categoryId);
					$album = $data->getAlbumName($albumId);
					$app->initThumbnailLastImport($images,$flexdata,$category,$album); //set the image thumbnail

					$xtpl->assign('PATH', $extPath);
					$xtpl->parse('viewLastImport');
					$content = $xtpl->out('viewLastImport');
				}
				break;
			default:
				break;	
		}
		return $this->pi_wrapInBaseClass($content);
	}
}

if (defined('TYPO3_MODE') && $TYPO3_CONF_VARS[TYPO3_MODE]['XCLASS']['ext/eco_gal/pi1/class.tx_ecogal_pi1.php'])	{
	include_once($TYPO3_CONF_VARS[TYPO3_MODE]['XCLASS']['ext/eco_gal/pi1/class.tx_ecogal_pi1.php']);
}
?>
