<?php
/***************************************************************
*	Copyright notice
*
*	(c) 2006 Fabien Udriot <fabien.udriot@ecodev.ch>
*	All rights reserved
*
*	This script is part of the TYPO3 project. The TYPO3 project is
*	free software; you can redistribute it and/or modify
*	it under the terms of the GNU General Public License as published by
*	the Free Software Foundation; either version 2 of the License, or
*	(at your option) any later version.
*
*	The GNU General Public License can be found at
*	http://www.gnu.org/copyleft/gpl.html.
*
*	This script is distributed in the hope that it will be useful,
*	but WITHOUT ANY WARRANTY; without even the implied warranty of
*	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.	See the
*	GNU General Public License for more details.
*
*	This copyright notice MUST APPEAR in all copies of the script!
***************************************************************/
/**
 * Plugin 'Photo gallery express' for the 'eco_gal' extension.
 *
 * @author	Fabien Udriot <fabien.udriot@ecodev.ch>
 */
	
class tx_appManager_ecogal{

	/* proprieties of the class */
	private $self;
	private $cObj;
	private $div;
	private $xtpl;
	private $util;
	private $user;
	private $db;
	private $fe;
	private $data;
	private $feLang;
	
	/***********************************************************
	 * CONSTRUCTOR PHP 5, pass objects by reference
	 ***********************************************************/	
	function __construct(&$self,&$cObj,&$div,&$xtpl,&$util,&$user,&$db,&$fe,&$data,$feLang){
		$this->self =& $self;
		$this->cObj =& $cObj;
		$this->div =& $div;
		$this->xtpl =& $xtpl;
		$this->util =& $util;
		$this->user =& $user;
		$this->db =& $db;
		$this->fe =& $fe;
		$this->data =& $data;
		$this->feLang = $feLang;
	}
	
	/***********************************************************
	 * INIT THE CATEGORY SELECT
	 ***********************************************************/	
	function initCategorySelect($categories){
		include('inc.appManager.php');
 		$xtpl->assign('VALUE', htmlspecialchars($self->pi_getLL('all_categories')));
 		//$xtpl->assign('URL',$self->pi_getPageLink($fe->id,'',array('category' => 'all')));
 		$xtpl->assign('ID', 'all');
		$xtpl->assign('CURRENT_CATEGORY', 'all');
	 	$xtpl->parse('viewPlayer.selectCategory.optionCategory');
		$index = 0;
		foreach ($categories as $category){
			$tmp = $div->xml2array($categories[$index]['flexform']);
			$xtpl->assign('VALUE', $self->pi_getFFvalue($tmp,'category','sDEF',$this->feLang));
			$xtpl->assign('ID', $category['category']);
			if($user->getKey('ses','category') == $category['category']){ //handle the select
				$xtpl->assign('SELECTED', 'selected="selected"');
				$xtpl->assign('CURRENT_CATEGORY', $category['category']);
			}
			else
				$xtpl->assign('SELECTED', '');
			$xtpl->parse('viewPlayer.selectCategory.optionCategory');	
			$index ++;
		}
	 	$xtpl->parse('viewPlayer.selectCategory');
	}
	
	/***********************************************************
	 * INIT THE ALBUM SELECT
	 ***********************************************************/	
	function initAlbumSelect($albums){
		include('inc.appManager.php');
 		$xtpl->assign('VALUE', htmlspecialchars($self->pi_getLL('all_albums')));
 		$xtpl->assign('ID', 'all');
		$xtpl->assign('CURRENT_ALBUM', 'all');
	 	$xtpl->parse('viewPlayer.selectAlbum.optionAlbum');
		$index = 0;
		foreach ($albums as $album){
			$tmp = $div->xml2array($albums[$index]['flexform']);
			$xtpl->assign('VALUE', $self->pi_getFFvalue($tmp,'album','sDEF',$this->feLang));
			$xtpl->assign('ID', $album['album']);
			if($user->getKey('ses','album') == $album['album']){
				$xtpl->assign('SELECTED', 'selected="selected"'); 
				$xtpl->assign('CURRENT_ALBUM', $category['album']);
			}
			else
				$xtpl->assign('SELECTED', '');
			$xtpl->parse('viewPlayer.selectAlbum.optionAlbum');	
			$index ++;
		}	
	 	$xtpl->parse('viewPlayer.selectAlbum');
	}
	
	/***********************************************************
	 * INIT THE SORT SELECT
	 ***********************************************************/	
	function initSortSelect(){
		include('inc.appManager.php');
		//init the sort select
		$xtpl->assign('CURRENT_SORT', 'DESC');
 		if($user->getKey('ses','sort') == 'DESC'){
 			$xtpl->assign('DESC_SELECTED', 'selected="selected"');
 		}
 		$xtpl->assign('DESC_VALUE', htmlspecialchars($self->pi_getLL('desc_sort')));
 		if($user->getKey('ses','sort') == 'ASC'){
 			$xtpl->assign('ASC_SELECTED', 'selected="selected"');
			$xtpl->assign('CURRENT_SORT', 'ASC');
 		}
 		$xtpl->assign('ASC_VALUE', htmlspecialchars($self->pi_getLL('asc_sort')));
	 	$xtpl->parse('viewPlayer.selectSort');
	}

	/***********************************************************
	 * INIT THE THUMNAILS
	 ***********************************************************/	
	function initThumbnailImage($images,$flexdata){
		include('inc.appManager.php');	
		//init some variables
		$thumbnailSize = $self->pi_getFFvalue($flexdata,'thumbnailSize','sPlayerPref');
		$imageSize = $self->pi_getFFvalue($flexdata,'imageSize','sPlayerPref');
		
		//get the categories translation
		$index = 1;
		foreach($images as $image){
			//Thumbnail
			$configThumbnail['file'] = 'uploads/tx_ecogal/'.$image['file'];
			$configThumbnail['altText'] = 'image';//$image['category'];
			$configThumbnail['file.']['height'] = $thumbnailSize; //resize the thumbnails
			$htmlThumbnail = $cObj->IMAGE($configThumbnail);
			//Image
			$configImage = array();
			$configImage['file'] = 'uploads/tx_ecogal/'.$image['file'];
			
			//SECURITY : CHECK IF THE FILE EXIST
			if(is_file($configImage['file'])){
				$fileInfo = getimagesize($configImage['file']);
				if($fileInfo[0] > $fileInfo[1]) //width is bigger
					$configImage['file.']['width'] = $imageSize; //resize the picture
				else
					$configImage['file.']['height'] = $imageSize / 1.3; //resize the picture, a bit less
					
				$htmlImage = $cObj->IMAGE($configImage);
				//parsing html
				$xtpl->assign('PATH_THUMBNAIL',$util->getImagePath($htmlThumbnail)); //$div->debug($GLOBALS['TEMP_IMAGES_ON_PAGE']);
				$xtpl->assign('PATH_IMAGE',$util->getImagePath($htmlImage)); 
				$xtpl->assign('COUNTER_IMAGE',$index);
				
			} 
			$xtpl->parse('viewPlayer.thumbnail');
			$index ++;	
		}
	}
	
	/***********************************************************
	 * INIT THE IMAGE CAPTION
	 ***********************************************************/	
	function initCaptionImage($images){
		include('inc.appManager.php');	
		foreach($images as $image){
			$tmp = $div->xml2array($image['flexform']);
			$xtpl->assign('CAPTION_TITLE', htmlspecialchars($self->pi_getFFvalue($tmp,'title','sDEF',$this->feLang)));
			$xtpl->assign('CAPTION_DESCRIPTION', htmlspecialchars($self->pi_getFFvalue($tmp,'description','sDEF',$this->feLang)));
			$xtpl->parse('viewPlayer.caption');
		}
	}

	/***********************************************************
	 * INIT THE FIRST IMAGE FROM THE GALLERY
	 ***********************************************************/	
	function initFirstImage($image,$flexdata){
		include('inc.appManager.php');
		//init some variables
		$imageSize = $self->pi_getFFvalue($flexdata,'imageSize','sPlayerPref');
		//processing ...
		$configImage['file'] = 'uploads/tx_ecogal/'.$image['file'];
		if(is_file($configImage['file'])){
			$fileInfo = getimagesize($configImage['file']);
			 if($fileInfo[0] > $fileInfo[1]) //width is bigger
				$configImage['file.']['width'] = $imageSize;//resize the picture
			else
				$configImage['file.']['height'] = $imageSize / 1.3; //resize the picture, a bit less
				
			$htmlImage = $cObj->IMAGE($configImage);
			//parsing html
			$xtpl->assign('PATH_IMAGE',$util->getImagePath($htmlImage)); 
			$tmp = $div->xml2array($image['flexform']);
	 		$xtpl->assign('CAPTION_TITLE', htmlspecialchars($self->pi_getFFvalue($tmp,'title','sDEF',$this->feLang)));
	 		$xtpl->assign('CAPTION_DESCRIPTION', htmlspecialchars($self->pi_getFFvalue($tmp,'description','sDEF',$this->feLang)));
		}
		else{ //handle the error
			$errorXtpl = new tx_xtemplate($self->tplPath.'error.tpl');
			$errorXtpl->parse('noImage');
			$xtpl->assign('CAPTION_TITLE',$errorXtpl->out('noImage'));
		}
	}
	
	/***********************************************************
	 * INIT THE THUMNAILS LAST IMPORT
	 ***********************************************************/	
	function initThumbnailLastImport($images,$flexdata,$category,$album){ 
		include('inc.appManager.php');
		//get some values
		$page = $fe->page;
		$url = $self->pi_getPageLink($fe->id);
		$arrangedUrl = $util->convertUrl($url);
		$thumbnailSize = $self->pi_getFFvalue($flexdata,'thumbnailSize','sLastImportPref');
		$pageId = $self->pi_getFFvalue($flexdata,'pageId','sLastImportPref');
		//begin processing...
		$xtpl->assign('CATEGORY',$category);
		$xtpl->assign('ALBUM',$album);
		$xtpl->assign('GO_PAGE_TITLE',$page['title']);
		$xtpl->assign('GO_BACK',$arrangedUrl);
		$xtpl->assign('URL_PLAYER',$self->pi_getPageLink($pageId));
		$urlCurrent = $util->replaceId($fe->id,$pageId,$self->pi_getPageLink($fe->id));	//$currentPageId, $pageId,$url
		foreach($images as $image){
			$configThumbnail['file'] = 'uploads/tx_ecogal/'.$image['file'];
			$configThumbnail['altText'] = 'image';//$image['category'];
			$configThumbnail['file.']['height'] = $thumbnailSize; //resize the thumbnails
			$htmlThumbnail = $cObj->IMAGE($configThumbnail);
			$xtpl->assign('IMAGE_ID',$image['uid']);
			$xtpl->assign('PATH_THUMBNAIL',$util->getImagePath($htmlThumbnail)); //$div->debug($GLOBALS['TEMP_IMAGES_ON_PAGE']);
			$xtpl->parse('viewLastImport.thumbnail');
		}
	}
	/***********************************************************
	 * INIT THE GO BACK PAGE
	 ***********************************************************/	
	function initGoBack(){
		include('inc.appManager.php');
		//get some values
		$xtpl->assign('GOBACK_TEXT',$self->pi_getLL('goBack_text'));
		$url = $util->reverseUrl($div->GPvar('goBack'));
		$xtpl->assign('GOBACK_URL',$util->formatUrl($url));
		$xtpl->assign('GOBACK_TITLE',$div->GPvar('goBackTitle'));
	 	$xtpl->parse('viewPlayer.goBack');
	}
	
	/***********************************************************
	 * INIT ALBUM VIEW
	 ***********************************************************/	
	function initAlbumView(&$records = array(),&$flexdata,$recordType = 'album'){
		include('inc.appManager.php');

		//get some values
		$thumbnailSize = $self->pi_getFFvalue($flexdata,'thumbnailSize','sAlbumPref');
		$colNumber = $self->pi_getFFvalue($flexdata,'colNumber','sAlbumPref');

		$xtpl->assign('ALBUM','all');
		$xtpl->assign('CATEGORY','all');
		$xtpl->assign('CLEAR_PIXEL',$thumbnailSize);
		$xtpl->assign('WIDTH',$self->pi_getFFvalue($flexdata,'gallerySize','sAlbumPref'));
		$xtpl->assign('WIDTH_COL',100/$colNumber);
		$loop = 0;
		foreach($records as $record){
			//get all images from a record
			$images = $data->getImagesByType($record['uid'],$recordType);
			$comma = '';
			$thumbnails = '';
			if(!empty($images)){
				foreach($images as $image){
					//reszie the thumbnails
					$configThumbnail['file'] = 'uploads/tx_ecogal/'.$image['file'];
					$configThumbnail['altText'] = 'image';//$image['category'];
					$configThumbnail['file.']['height'] = $thumbnailSize;
					$htmlThumbnail = $cObj->IMAGE($configThumbnail);
					$thumbnails .= $comma.'\''.$util->getImagePath($htmlThumbnail).'\'';
					if($comma == ''){
						$comma = ',';
						$thumbnail = $util->getImagePath($htmlThumbnail);
					}
				}
				$xtpl->assign('ID',$loop);
				$xtpl->assign('THUMBNAIL',$thumbnail);
				$xtpl->assign('THUMBNAILS',$thumbnails);
				$xtpl->assign(strtoupper($recordType),$record[$recordType]); //category or album
				$loop ++;
				
				$_flexdata = $div->xml2array($record['flexform']);
				$description = htmlspecialchars($self->pi_getFFvalue($_flexdata,'description','sDEF',$this->feLang));
				if($description == '')
					$xtpl->assign('STYLE','center');
				else
					$xtpl->assign('STYLE','justify');
				$xtpl->assign('DESCRIPTION',$description);
				$xtpl->assign('TITLE',htmlspecialchars($self->pi_getFFvalue($_flexdata,$recordType,'sDEF',$this->feLang))); //category - album
					
				$xtpl->parse('viewAlbum.row.col');
				if($loop % $colNumber == 0)
					$xtpl->parse('viewAlbum.row');
			}
		}
		$xtpl->assign('TITLE',htmlspecialchars($self->pi_getFFvalue($_flexdata,'album','sDEF',$this->feLang)));
		if($loop % $colNumber != 0) //reparse if it is even
			$xtpl->parse('viewAlbum.row');
	}
	/***********************************************************
	 * ADD CSS /JS TO THE FRONTEND
	 ***********************************************************/	
	function addCss($file){
		include('inc.appManager.php');
		$fe->additionalHeaderData[$file] = '<link rel="stylesheet" href="'.t3lib_extMgm::extRelPath('eco_gal').'pi1/css/'.$file.'" type="text/css" media="screen" />';
	}
	
	function addJs($file){
		include('inc.appManager.php');
		$fe->additionalHeaderData[$file] = '<script type="text/javascript" src="'.t3lib_extMgm::extRelPath('eco_gal').'pi1/js/'.$file.'"></script>';

	}

}

?>
