<?php
/***************************************************************
*	Copyright notice
*
*	(c) 2006 Fabien Udriot <fabien.udriot@ecodev.ch>
*	All rights reserved
*
*	This script is part of the TYPO3 project. The TYPO3 project is
*	free software; you can redistribute it and/or modify
*	it under the terms of the GNU General Public License as published by
*	the Free Software Foundation; either version 2 of the License, or
*	(at your option) any later version.
*
*	The GNU General Public License can be found at
*	http://www.gnu.org/copyleft/gpl.html.
*
*	This script is distributed in the hope that it will be useful,
*	but WITHOUT ANY WARRANTY; without even the implied warranty of
*	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.	See the
*	GNU General Public License for more details.
*
*	This copyright notice MUST APPEAR in all copies of the script!
***************************************************************/
/**
 * Plugin 'Photo gallery express' for the 'eco_gal' extension.
 *
 * @author	Fabien Udriot <fabien.udriot@ecodev.ch>
 */
	
class tx_dataManager_ecogal{
	
	/* proprieties of the class */
	private $self;
	private $util;
	private $user;
	private $db;
	private $pid;
	
	/***********************************************************
	 * CONSTRUCTOR PHP 5, pass objects by reference
	 ***********************************************************/	
	function __construct(&$self,&$cObj,&$util,&$user,&$db){
		$this->self =& $self;
		$this->util =& $util;
		$this->user =& $user;
		$this->db =& $db;
		$this->pid = $cObj->data['pages'];
		if($this->pid == '')
			exit('<b>eco_gal error :</b> please define a Startingpoint for content id '.$cObj->data['uid']);
	}

	/***********************************************************
	 * RETURN ALL CATEGORIES (ARRAY)
	 ***********************************************************/	
	function getCategories(){
		include('inc.dataManager.php');	
		return	$db->exec_SELECTgetRows('uid,category,flexform','tx_ecogal_category','hidden = 0 AND deleted = 0 AND pid='.$this->pid);
	}
	
	/***********************************************************
	 * RETURN ALL ALBUMS (ARRAY)
	 ***********************************************************/	
	function getAlbums(){
		include('inc.dataManager.php');
		return	$db->exec_SELECTgetRows('uid,album,flexform','tx_ecogal_album','hidden = 0 AND deleted = 0 AND pid='.$this->pid);
	}
	
	/***********************************************************
	 * RETURN ALL IMAGES (ARRAY)
	 ***********************************************************/	
	function getImages(){
		include('inc.dataManager.php');
		//get all images
		$sqlClause = 'hidden = 0 AND deleted = 0 AND pid='.$this->pid;//take the not hidden picture
		//get the id category
		if($user->getKey('ses','category') != 'all'){
			$res = $db->exec_SELECTquery('uid','tx_ecogal_category',"category='".$user->getKey('ses','category')."'");
			$categoryId =	$util->getRowArrays($res); //make an array from the resultset
			$sqlClause .= " AND category LIKE '%$categoryId[0]%'";		
		}
		//get the id album
		if($user->getKey('ses','album') != 'all'){
			$res = $db->exec_SELECTquery('uid','tx_ecogal_album',"album='".$user->getKey('ses','album')."'");
			$albumId =	$util->getRowArrays($res); //make an array from the resultset
			$sqlClause .= " AND album LIKE '%$albumId[0]%'";
		}
		return	$db->exec_SELECTgetRows('*','tx_ecogal_image',$sqlClause,'','crdate '.$user->getKey('ses','sort'));
	}
	
	/***********************************************************
	 * RETURN ALL IMAGES BY ALBUM (ARRAY)
	 ***********************************************************/	
 	function getImagesByType($albumId,$recordType){
		include('inc.dataManager.php');
		return	$db->exec_SELECTgetRows('*','tx_ecogal_image',$recordType." LIKE '%$albumId%'  AND hidden = 0 AND deleted = 0 AND pid=".$this->pid);
 	}
		 
	/***********************************************************
	 * RETURN AN IMAGE ARRAY
	 ***********************************************************/	
	function getImage($imageId){
		include('inc.dataManager.php');
		$result = $db->exec_SELECTgetRows('*','tx_ecogal_image','uid='.$imageId);
		return	$result[0];
	}
	
	/***********************************************************
	 * RETURN BOOL IF CATEGORY EXIST
	 ***********************************************************/	
	function existsCategory($id){
		include('inc.dataManager.php');
		$response = false;
		$result = $db->exec_SELECTgetRows('uid','tx_ecogal_category',"uid = ".$id);
		if(count($result) != 0 || $id == 0) //it means the array is not nul => the category exists
			$response = true;
		return $response;
	}
	function existsAlbum($id){
		include('inc.dataManager.php');
		$response = false;
		$result = $db->exec_SELECTgetRows('uid','tx_ecogal_album',"uid = ".$id);
		if(count($result) != 0 || $id == 0) //it means the array is not nul => the category exists
			$response = true;
		return $response;
	}
	
	/***********************************************************
	 * RETURN BOOL IF CATEGORY EXIST
	 ***********************************************************/
	function isCategoryVisible2($id){
		include('inc.dataManager.php');
		$response = false;
		$result = $db->exec_SELECTgetRows('hidden','tx_ecogal_category',"uid = ".$id);
		if($result[0]['hidden'] == 0) //it means the array is not nul => the category exists
			$response = true;
		return $response;
	}
	function isAlbumVisible2($id){
		include('inc.dataManager.php');
		$response = false;
		$result = $db->exec_SELECTgetRows('hidden','tx_ecogal_album',"uid = ".$id);
		if($result[0]['hidden'] == 0) //it means the array is not nul => the category exists
			$response = true;
		return $response;
	}
	
	/***********************************************************
	 * RETURN BOOL IF CATEGORY EXIST
	 ***********************************************************/	
	function getLastImportImages($categoryId,$albumId,$imageNum){
		include('inc.dataManager.php');
		$response = array();
		
		$categorySQL = '';
		$albumSQL = '';
		$and = '';
		if($categoryId != 0 && $this->isCategoryVisible2($categoryId))
			$categorySQL = "category LIKE '%$categoryId%'";
		if($albumId != 0 && $this->isAlbumVisible2($albumId)){
			if($categorySQL != '')
				$and = " AND ";
			$albumSQL = "$and album LIKE '%$albumId%'";
		}
			
		//check if the category is hidden or not
		if($this->isCategoryVisible2($categoryId) || $this->isAlbumVisible2($albumId))
			$response =	$db->exec_SELECTgetRows('*','tx_ecogal_image',"$categorySQL $albumSQL AND hidden = 0 AND deleted = 0 AND pid=".$this->pid,'','`crdate` DESC',$imageNum);
		return $response;
	}
	
	/***********************************************************
	 * RETURN ALL CATEGORIES (ARRAY)
	 ***********************************************************/	
	function getCategoryName($id){
		include('inc.dataManager.php');			
		$res = $db->exec_SELECTquery('category','tx_ecogal_category','uid='.$id);
		$result = $util->getRowArrays($res);
		return $result[0];
	}
	function getAlbumName($id){
		include('inc.dataManager.php');			
		$res = $db->exec_SELECTquery('album','tx_ecogal_album','uid='.$id);
		$result = $util->getRowArrays($res);
		return $result[0];
	}
	
	/***********************************************************
	 * RETURN VALUES FROM FLEXDATA
	 ***********************************************************/	
	function isCategoryVisible(&$flexdata){
		include('inc.dataManager.php');
		return	$self->pi_getFFvalue($flexdata,'isCategoryVisible','sPlayerPref');
	}
	function isAlbumVisible(&$flexdata){
		include('inc.dataManager.php');	
		return	$self->pi_getFFvalue($flexdata,'isAlbumVisible','sPlayerPref');
	}
	function isSortingVisible(&$flexdata){
		include('inc.dataManager.php');
		return	$self->pi_getFFvalue($flexdata,'isSortingVisible','sPlayerPref');
	}
}
?>
