<?php
/***************************************************************
*	Copyright notice
*
*	(c) 2006 Fabien Udriot <fabien.udriot@ecodev.ch>
*	All rights reserved
*
*	This script is part of the TYPO3 project. The TYPO3 project is
*	free software; you can redistribute it and/or modify
*	it under the terms of the GNU General Public License as published by
*	the Free Software Foundation; either version 2 of the License, or
*	(at your option) any later version.
*
*	The GNU General Public License can be found at
*	http://www.gnu.org/copyleft/gpl.html.
*
*	This script is distributed in the hope that it will be useful,
*	but WITHOUT ANY WARRANTY; without even the implied warranty of
*	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.	See the
*	GNU General Public License for more details.
*
*	This copyright notice MUST APPEAR in all copies of the script!
***************************************************************/
/**
 * Plugin 'Photo gallery express' for the 'eco_gal' extension.
 *
 * @author	Fabien Udriot <fabien.udriot@ecodev.ch>
 */
	
class tx_jcManager_ecogal{
	
	/* proprieties of the class */
	private $self;
	private $cObj;
	private $div;
	private $fileConfig;
	private $cssPath;
	private $jsPath;
	private $tplPath;
	private $extPath;
	
	private $configFile;
	private $cssFile;
	private $jsFile;
	
	/***********************************************************
	 * CONSTRUCTOR PHP 5, pass objects by reference
	 ***********************************************************/	
	function __construct(&$self,&$cObj,&$div){
		$this->self =& $self;
		$this->cObj =& $cObj;
		$this->div =& $div;
		$this->configFile = t3lib_extMgm::siteRelPath('eco_gal').'pi1/config/'.$cObj->data['uid'].'_config.txt';
		$this->cssFile = t3lib_extMgm::siteRelPath('eco_gal').'pi1/css/'.$cObj->data['uid'].'_playerView.css';
		$this->jsFile = t3lib_extMgm::siteRelPath('eco_gal').'pi1/js/'.$cObj->data['uid'].'_playerView.js';
		$this->cssPath = t3lib_extMgm::siteRelPath('eco_gal').'pi1/css/';
		$this->jsPath = t3lib_extMgm::siteRelPath('eco_gal').'pi1/js/';
		$this->tplPath = t3lib_extMgm::siteRelPath('eco_gal').'pi1/tpl/';
		$this->extPath = t3lib_extMgm::siteRelPath('eco_gal').'pi1/';
	}
	/***********************************************************
	 * RETURN TRUE / FALSE IF THE CONFIG HAS CHANGED OR NOT
	 ***********************************************************/	
	function isConfigChanged(&$flexdata){
		include('inc.jcManager.php');
		$result = true;
			
		if(file_exists($this->configFile) && file_exists($this->cssFile) && file_exists($this->jsFile)){
			$config = $cObj->fileResource($this->configFile);
			$config = unserialize($config);		
			if($self->pi_getFFvalue($flexdata,'imageSize','sPlayerPref') == $self->pi_getFFvalue($config,'imageSize','sPlayerPref') &&
 				 $self->pi_getFFvalue($flexdata,'thumbnailSize','sPlayerPref') == $self->pi_getFFvalue($config,'thumbnailSize','sPlayerPref') &&
 				 $self->pi_getFFvalue($flexdata,'gallerySize','sPlayerPref') == $self->pi_getFFvalue($config,'gallerySize','sPlayerPref') &&
 				 $self->pi_getFFvalue($flexdata,'bgColor','sPlayerPref') == $self->pi_getFFvalue($config,'bgColor','sPlayerPref')
				)
				$result = false;
		}
		return $result;
	}
	
	/***********************************************************
	 * RETURN TRUE / FALSE IF THE CONFIG HAS CHANGED
	 ***********************************************************/	
	function changeConfig(&$flexdata){
		include('inc.jcManager.php');
		/*  handle css  */
		$imageHeight = $self->pi_getFFvalue($flexdata,'imageSize','sPlayerPref');
		$thumbnailHeight = $self->pi_getFFvalue($flexdata,'thumbnailSize','sPlayerPref');
		$gallerySize = $self->pi_getFFvalue($flexdata,'gallerySize','sPlayerPref');
		$bgColor = $self->pi_getFFvalue($flexdata,'bgColor','sPlayerPref');
		if($bgColor == null) $bgColor = '#FFF';
		$xtpl = new tx_xtemplate($this->tplPath.'playerView.tpl.css');
//				echo 'write';
//		'300' => 60,
//		'350' => 70,
//		'400' => 80,
//		'450' => 90,
//		'500' => 100,
//		'550' => 110,
//		'600' => 120,
		$xtpl->assign('IMAGE_HEIGHT', $imageHeight - $imageHeight * 0.2);//hmmm. not very clear, but it works
		$xtpl->assign('ARROW_HEIGHT', $thumbnailHeight);//pixel
		$xtpl->assign('ARROW_TOP', $thumbnailHeight / 10);//pixel
		$xtpl->assign('GALLERY_SIZE', $gallerySize);//pixel
		$xtpl->assign('BG_COLOR', $bgColor);
		$xtpl->assign('PATH', $this->extPath);
		$xtpl->parse('main');
		
		if(! $div->writeFile($this->cssFile,$xtpl->out('main'))) //write file
			return false;
		if(! $div->writeFile($this->configFile,serialize($flexdata))) //write config
			return false;
			
		/*  handle js  */
		$xtpl = new tx_xtemplate($this->tplPath.'playerView.tpl.js');
		$xtpl->assign('PATH', $this->extPath);
		$xtpl->assign('SLIDE_WIDTH', $gallerySize); //pixel
		$xtpl->parse('main');
		
		if(! $div->writeFile($this->jsFile,$xtpl->out('main'))) //write file
			return false;

		return true;
	}
}
?>
