<?php
/***************************************************************
 *	Copyright notice
 *
 *	(c) 2006 Fabien Udriot <fabien.udriot@ecodev.ch>
 *	All rights reserved
 *
 *	This script is part of the TYPO3 project. The TYPO3 project is
 *	free software; you can redistribute it and/or modify
 *	it under the terms of the GNU General Public License as published by
 *	the Free Software Foundation; either version 2 of the License, or
 *	(at your option) any later version.
 *
 *	The GNU General Public License can be found at
 *	http://www.gnu.org/copyleft/gpl.html.
 *
 *	This script is distributed in the hope that it will be useful,
 *	but WITHOUT ANY WARRANTY; without even the implied warranty of
 *	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.	See the
 *	GNU General Public License for more details.
 *
 *	This copyright notice MUST APPEAR in all copies of the script!
 ***************************************************************/
/**
 * Plugin 'Photo gallery express' for the 'eco_gal' extension.
 *
 * @author	Fabien Udriot <fabien.udriot@ecodev.ch>
 */

$extPath = t3lib_extMgm::siteRelPath('eco_gal'); // $GLOBALS['TYPO3_LOADED_EXT']['eco_gal']

require_once(PATH_tslib.'class.tslib_pibase.php');
require_once($extPath.'share/lib/class.tx_damSelector.php');
require_once($extPath.'ply1/lib/class.appManager.php');
require_once($extPath.'ply1/lib/class.dataManager.php'); //include useful staff for db manager
require_once(t3lib_extMgm::extPath('jquery')."class.tx_jquery.php");

// init the global $LANG useful for tx_damSelector when no backendlogin
require_once('typo3/sysext/lang/lang.php');
if($LANG == null){
	global $LANG;
	$LANG = t3lib_div::makeInstance('language');
}

class tx_ecogal_ply1 extends tslib_pibase {
	var $prefixId = 'tx_ecogal_ply1';		// Same as class name
	var $scriptRelPath = 'ply1/class.tx_ecogal_ply1.php';	// Path to this script relative to the extension dir.
	var $extKey = 'eco_gal';	// The extension key.
	var $pi_checkCHash = TRUE;
	var $xtpl;
	var $sel;
	var $data;
	var $flexdata;
	var $defaultLang;
	var $css;

	/**
	 * The main method of the PlugIn
	 *
	 * @param	string		$content: The PlugIn content
	 * @param	array		$conf: The PlugIn configuration
	 * @return	The content that is displayed on the website
	 */
	function main($content,$conf){
		/* *********************************/
		/* init some objects & parameters  */
		/* *********************************/
		$fe =& $GLOBALS['TSFE']; //return tslib_fe
		$fe->set_no_cache(); //necessary... since it changes all the time
		$user =& $fe->fe_user; //return tslib_feUserAuth
		$div = t3lib_div::makeInstance('t3lib_div');
		$this->pi_initPIflexForm();
		$this->sel = new tx_damSelector();
		$this->flexdata = t3lib_div::xml2array($this->cObj->data['ply1_flexform']);
		$this->css = new tx_xtemplate(t3lib_extMgm::siteRelPath($this->extKey).'ply1/tpl/ecogal_ply1_css.tpl');
		$this->xtpl = new tx_xtemplate(t3lib_extMgm::siteRelPath($this->extKey).'ply1/tpl/ecogal_ply1.tpl');
		$this->data = new tx_dataManager_ply1();
		$app = new tx_appManager_ply1($this);
		$this->defaultLang = $this->getFFvalue('defaultLang','sPref');

		/* *********************/
		/* handle the css + js */
		/* *********************/
		tx_jquery::includeLib(); //jquery lib
		$extPath = t3lib_extMgm::extRelPath('eco_gal');
		$fe->additionalHeaderData['eco_ply1_css_1'] = '<link rel="stylesheet" href="'.$extPath.'share/css/eco_gal.css" type="text/css" media="screen" />';
		$app->initCss();
		$fe->additionalHeaderData['eco_alb1_css_2'] = $this->css->out('css');
		$fe->additionalHeaderData['eco_ply1_js1'] = '<script type="text/javascript" src="'.$extPath.'ply1/js/playerView.js"></script>';
		$fe->additionalHeaderData['eco_ply1_js2'] = '<script type="text/javascript" src="'.$extPath.'ply1/js/playerCom.js"></script>';
		$fe->additionalHeaderData['eco_ply1_js3'] = '<script type="text/javascript" src="'.$extPath.'share/js/urlparser.js"></script>';

		/* *****************/
		/* handle the html */
		/* *****************/
		$this->xtpl->assign('TT_CONTENT', $this->cObj->data['uid']);
		$this->xtpl->assign('DEFAULT_ORDER', $this->getFFvalue('defaultOrder','sPref'));
		$this->xtpl->assign('PLAYER_URL', $extPath.'ply1/getPly1.php');
		$this->xtpl->assign('PATH_IMAGE_STATIC', $extPath.'ply1/img/');
		$this->xtpl->assign('URL', $this->pi_getPageLink($fe->id));

		$selections = explode(',',$this->getFFvalue('selections','sSource'));
		if($selections[0] != ''){
			$selection = $selections[0];
			if(!$this->data->existSelection($selection)){
				die('PLUGIN ECO_GAL ERROR : selection '.$selection.' does not exist !');
			}
		}
		else{
			die('PLUGIN ECO_GAL ERROR : no album source defined for <b>content element '.$this->cObj->data['uid'].'</b> on page '.$this->cObj->data['pid']);
		}
			
		//SQL limit
		if($this->getFFvalue('limit','sPref') != 0){
			$this->sel->max = $this->getFFvalue('limit','sPref');
		}
		
		//SQL order
		$field = $this->getFFvalue('defaultField','sPref');
		$order = $this->getFFvalue('defaultOrder','sPref');
		$this->sel->sort = $field.' '.$order;

		$images = $this->sel->getMedias($selection);
		//$images = array_reverse($images);
		$app->initArrow();
		$app->initCaptionImage($images);//set the image caption
		$app->initFirstImage($images[0]);//init the first default image
		$app->initThumbnailImage($images); //set the image thumbnail
		$app->initJs();

		//display a sorting field
		if($this->getFFvalue('isSortingVisible','sPref') == '1'){
			$app->initSortSelect();
		}
		//display other albums
		if(count($selections) > 1){
			$titles = $this->data->getAlbumsTitle($selections);
			$app->initAlbumSelect($titles,$selection);
		}

		$this->xtpl->parse('viewPlayer.loadingWaitChangeGal');
		$this->xtpl->parse('viewPlayer');

		return $this->pi_wrapInBaseClass($this->xtpl->out('viewPlayer'));
	}
	
	/**
	 * extract a flexform's value from a specific sheet
	 */
	function getFFValue($field,$sheet){
		return $this->pi_getFFvalue($this->flexdata,$field,$sheet);
	}
}

if (defined('TYPO3_MODE') && $TYPO3_CONF_VARS[TYPO3_MODE]['XCLASS']['ext/eco_gal/ply1/class.tx_ecogal_ply1.php'])	{
	include_once($TYPO3_CONF_VARS[TYPO3_MODE]['XCLASS']['ext/eco_gal/ply1/class.tx_ecogal_ply1.php']);
}
?>
