<?php
/***************************************************************
*	Copyright notice
*
*	(c) 2006 Fabien Udriot <fabien.udriot@ecodev.ch>
*	All rights reserved
*
*	This script is part of the TYPO3 project. The TYPO3 project is
*	free software; you can redistribute it and/or modify
*	it under the terms of the GNU General Public License as published by
*	the Free Software Foundation; either version 2 of the License, or
*	(at your option) any later version.
*
*	The GNU General Public License can be found at
*	http://www.gnu.org/copyleft/gpl.html.
*
*	This script is distributed in the hope that it will be useful,
*	but WITHOUT ANY WARRANTY; without even the implied warranty of
*	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.	See the
*	GNU General Public License for more details.
*
*	This copyright notice MUST APPEAR in all copies of the script!
***************************************************************/
/**
 * Class that adds the wizard icon.
 *
 * @author	Fabien Udriot <fabien.udriot@ecodev.ch>
 */



class tx_ecogal_ply1_wizicon {

	/**
	 * Processing the wizard items array
	 *
	 * @param	array		$wizardItems: The wizard items
	 * @return	Modified array with wizard items
	 */
	function proc($wizardItems)	{
		global $LANG;
		
		$LL = $this->includeLocalLang();
		$wizardItems['plugins_tx_ecogal_ply1'] = array(
			'icon'=>t3lib_extMgm::extRelPath('eco_gal').'ply1/ce_wiz.gif',
			'title'=> $LANG->getLLL('wizardContext_ply1',$LL),
			'description'=> $LANG->getLLL('descriptionWizardContext_ply1',$LL),
			'tt_content_defValues' => Array('CType' => 'eco_gal_ply1'),
			);

		return $wizardItems;
	}

		/**
		 * Includes the locallang file for the 'tt_news' extension
		 *
		 * @return array The LOCAL_LANG array
		 */
		function includeLocalLang(){
			$xml = file_get_contents(t3lib_extMgm::extPath('eco_gal').'locallang_db.xml');
			$div = t3lib_div::makeInstance('t3lib_div');
			//It seems to be an encoding bug. Typo3 expects a iso-8859-1 string (put <xml encoding="iso-8859-1"> a the top of the xml file)
			$array = $div->xml2array(utf8_decode($xml));
			return $array['data'];
		}
}

if (defined('TYPO3_MODE') && $TYPO3_CONF_VARS[TYPO3_MODE]['XCLASS']['ext/eco_doc/ply1/class.tx_ecogal_ply1_wizicon.php'])	{
	include_once($TYPO3_CONF_VARS[TYPO3_MODE]['XCLASS']['ext/eco_doc/ply1/class.tx_ecogal_ply1_wizicon.php']);
}

?>