<?php
/***************************************************************
 *	Copyright notice
 *
 *	(c) 2006 Fabien Udriot <fabien.udriot@ecodev.ch>
 *	All rights reserved
 *
 *	This script is part of the TYPO3 project. The TYPO3 project is
 *	free software; you can redistribute it and/or modify
 *	it under the terms of the GNU General Public License as published by
 *	the Free Software Foundation; either version 2 of the License, or
 *	(at your option) any later version.
 *
 *	The GNU General Public License can be found at
 *	http://www.gnu.org/copyleft/gpl.html.
 *
 *	This script is distributed in the hope that it will be useful,
 *	but WITHOUT ANY WARRANTY; without even the implied warranty of
 *	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.	See the
 *	GNU General Public License for more details.
 *
 *	This copyright notice MUST APPEAR in all copies of the script!
 ***************************************************************/
/**
 * Plugin 'Photo gallery express' for the 'eco_gal' extension.
 *
 * @author	Fabien Udriot <fabien.udriot@ecodev.ch>
 */


// Exit, if script is called directly (must be included via eID in index_ts.php)
if (!defined ('PATH_typo3conf')) 	die ('Could not access this script directly!');

$extPath = t3lib_extMgm::siteRelPath('eco_gal');
require_once($extPath.'share/lib/class.tx_damSelector.php');
require_once($extPath.'ply1/lib/class.appManager.php');
require_once($extPath.'ply1/lib/class.dataManager.php');

//require class in order to get a TSFE
require_once(PATH_t3lib.'class.t3lib_page.php');

//require class for a cObj
require_once(PATH_t3lib.'class.t3lib_TStemplate.php');
require_once(PATH_t3lib.'class.t3lib_stdGraphic.php');
require_once(PATH_tslib.'class.tslib_gifbuilder.php');
require_once(PATH_tslib.'class.tslib_content.php');

// Connect to database + init user
tslib_eidtools::connectDB();
$user = tslib_eidtools::initFeUser();

//init global $TCA
$temp_TSFEclassName = t3lib_div::makeInstanceClassName('tslib_fe');
$TSFE = new $temp_TSFEclassName($TYPO3_CONF_VARS,0,0);
$TSFE->includeTCA();
$TSFE->sys_page = t3lib_div::makeInstance('t3lib_pageSelect');

//init a $cObj
$TSFE->tmpl = t3lib_div::makeInstance('t3lib_TStemplate');
$TSFE->tmpl->init();
$GLOBALS['TSFE']->config['config']['meaningfulTempFilePrefix'] = array(); //why ? no idea but it works so.

// init the global $LANG useful for category selection
require_once('typo3/sysext/lang/lang.php');
if($LANG == null){
	global $LANG;
	$LANG = t3lib_div::makeInstance('language');
}

$plugin = new tx_ecogal_getPly1();
$plugin->main();

class tx_ecogal_getPly1{

	var $extKey = 'eco_gal';	// The extension key.
	var $xtpl;
	var $sel;
	var $data;
	var $flexdata;
	var $cObj;

	/**
	 * The main method of the PlugIn
	 *
	 * @param	string		$content: The PlugIn content
	 * @param	array		$conf: The PlugIn configuration
	 * @return	The content that is displayed on the website
	 */
	function main(){

		$this->cObj = t3lib_div::makeInstance('tslib_cObj');
		$div = t3lib_div::makeInstance('t3lib_div');
		$this->sel = new tx_damSelector();
		$this->xtpl = new tx_xtemplate(t3lib_extMgm::siteRelPath($this->extKey).'ply1/tpl/ecogal_ply1.tpl');
		$this->data = new tx_dataManager_ply1();
		$app = new tx_appManager_ply1($this);
		$tt_content = $this->data->getTTContent($div->_POST('tt_content'));
		
		if($div->_POST('eco_gal') == 'ply1'){
			$this->flexdata = t3lib_div::xml2array($tt_content['ply1_flexform']);
		}
		elseif($div->_POST('eco_gal') == 'alb1'){
			$this->flexdata = t3lib_div::xml2array($tt_content['alb1_flexform']);
		}
		else{
			die('ERROR : variable eco_gal not defined');
		}
		
		/* *****************/
		/* handle the html */
		/* *****************/
		$extPath = t3lib_extMgm::siteRelPath('eco_gal');
		$this->xtpl->assign('PATH_IMAGE_STATIC', $extPath.'ply1/img/');
		$this->xtpl->assign('URL', $div->_POST('pathName'));

		$selection = $div->_POST('selection');
		if(!$this->data->existSelection($selection)){
			die('PLUGIN ECO_GAL ERROR : selection '.$selection.' does not exist !');
		}

		//SQL limit
		if($this->getFFvalue('limit','sPref') != 0){
			$this->sel->max = $this->getFFvalue('limit','sPref');
		}
		//SQL order
		$field = $this->getFFvalue('defaultField','sPref');
		$order = $div->_POST('order');
		$this->sel->sort = $field.' '.$order;
		
		$images = $this->sel->getMedias($selection);
		$app->initArrow();
		$app->initCaptionImage($images);//set the image caption
		$app->initFirstImage($images[0]);//init the first default image
		$app->initThumbnailImage($images); //set the image thumbnail

		$this->xtpl->parse('viewPlayer');
		echo $this->xtpl->out('viewPlayer');
	}

	/**
	 * extract a flexform's value from a specific sheet
	 */
	function getFFValue($field,$sheet){
		return $this->pi_getFFvalue($this->flexdata,$field,$sheet);
	}
	
	function pi_getFFvalue($T3FlexForm_array,$fieldName,$sheet='sDEF',$lang='lDEF',$value='vDEF'){
		$sheetArray = is_array($T3FlexForm_array) ? $T3FlexForm_array['data'][$sheet][$lang] : '';
		if (is_array($sheetArray)){
			return $this->pi_getFFvalueFromSheetArray($sheetArray,explode('/',$fieldName),$value);
		}
	}

	function pi_getFFvalueFromSheetArray($sheetArray,$fieldNameArr,$value){

		$tempArr=$sheetArray;
		foreach($fieldNameArr as $k => $v){
			if (t3lib_div::testInt($v)){
				if (is_array($tempArr)){
					$c=0;
					foreach($tempArr as $values){
						if ($c==$v)     {
							#debug($values);
							$tempArr=$values;
							break;
						}
						$c++;
					}
				}
			} else{
				$tempArr = $tempArr[$v];
			}
		}
		return $tempArr[$value];
	}
}
?>
