<?php
/***************************************************************
 *	Copyright notice
 *
 *	(c) 2006 Fabien Udriot <fabien.udriot@ecodev.ch>
 *	All rights reserved
 *
 *	This script is part of the TYPO3 project. The TYPO3 project is
 *	free software; you can redistribute it and/or modify
 *	it under the terms of the GNU General Public License as published by
 *	the Free Software Foundation; either version 2 of the License, or
 *	(at your option) any later version.
 *
 *	The GNU General Public License can be found at
 *	http://www.gnu.org/copyleft/gpl.html.
 *
 *	This script is distributed in the hope that it will be useful,
 *	but WITHOUT ANY WARRANTY; without even the implied warranty of
 *	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.	See the
 *	GNU General Public License for more details.
 *
 *	This copyright notice MUST APPEAR in all copies of the script!
 ***************************************************************/
/**
 * Plugin 'Photo gallery express' for the 'eco_gal' extension.
 *
 * @author	Fabien Udriot <fabien.udriot@ecodev.ch>
 */

class tx_appManager_ply1{

	/* object proprieties  */
	private $self;
	private $cObj;
	private $xtpl;
	private $data;
	private $flexdata;
	private $sizeDivisor = 1.2;
	private $lang;
	private $css; //ply1 css put in the header

	/***********************************************************
	 * CONSTRUCTOR PHP 5, pass objects by reference
	 ***********************************************************/
	function __construct(&$self){
		$this->self =& $self;
		$this->cObj =& $this->self->cObj;
		$this->xtpl =& $this->self->xtpl;
		$this->sel =& $this->self->sel;
		$this->data =& $this->self->data;
		$this->flexdata =& $this->self->flexdata;
		$this->sel =& $this->self->sel;
		$this->lang =& $this->self->defaultLang;
		$this->css =& $self->css;
	}


	/***********************************************************
	 * INIT THE ARROW
	 ***********************************************************/
	function initArrow(){
		$thumbnailHeight = $this->self->pi_getFFvalue($this->flexdata,'thumbnailSize','sPref');
		$browser = t3lib_div::clientInfo();
		if($browser['BROWSER'] == 'msie'){
			$ext = '.gif';
		}
		else{
			$ext = '.png';
		}
		$this->xtpl->assign('ARROW_LEFT', t3lib_extMgm::siteRelPath('eco_gal').'ply1/img/arr-left-'.$thumbnailHeight.$ext);
		$this->xtpl->assign('ARROW_RIGHT', t3lib_extMgm::siteRelPath('eco_gal').'ply1/img/arr-right-'.$thumbnailHeight.$ext);
		$this->xtpl->assign('THUMB_SIZE', $thumbnailHeight);

	}

	/***********************************************************
	 * INIT THE JAVASCRIPT + CSS
	 ***********************************************************/
	function initJs(){
		$flexdata =& $this->flexdata;
		$gallerySize = $this->getFFvalue('gallerySize','sPref');

		/*  handle js  */
		$this->xtpl->assign('PATH', t3lib_extMgm::extRelPath('eco_gal'));
		$this->xtpl->assign('SLIDE_WIDTH', $gallerySize); //pixel
		$this->xtpl->parse('viewPlayer.js');
	}

	/***********************************************************
	 * INIT THE JAVASCRIPT + CSS FOR PLAYER 1
	 ***********************************************************/
	function initCss(){
		$flexdata =& $this->flexdata;
		$imageHeight = $this->getFFvalue('imageSize','sPref');
		$thumbnailHeight = $this->getFFvalue('thumbnailSize','sPref');
		$gallerySize = $this->getFFvalue('gallerySize','sPref');
		$bgColor = $this->getFFvalue('bgColor','sPref');

		if($bgColor == null) $bgColor = '#FFF';
		switch($imageHeight){
			case 300:
				$imgHeight = 300;
				break;
			case 350:
				$imgHeight = 340;
				break;
			case 400:
				$imgHeight = 390;
				break;
			case 450:
				$imgHeight = 430;
				break;
			case 500:
				$imgHeight = 470;
				break;
			case 550:
				$imgHeight = 510;
				break;
			case 600:
				$imgHeight = 560;
				break;
		}

		$this->css->assign('THUMBNAIL_HEIGHT', $thumbnailHeight + 8);
		$this->css->assign('IMAGE_HEIGHT', $imgHeight);
		$this->css->assign('ARROW_HEIGHT', $thumbnailHeight);//pixel
		$this->css->assign('ARROW_TOP', $thumbnailHeight / 10);//pixel
		$this->css->assign('GALLERY_SIZE', $gallerySize);//pixel the height of the gallery
		$this->css->assign('WAIT_MSG_TOP', $imgHeight / 2);//pixel the height of the wait msg

		//left : 150px; -> 400 ($gallerySize)
		//left : 200px; -> 500  ($gallerySize)
		//left : 250px; -> 600 ($gallerySize)
		$this->css->assign('WAIT_MSG_LEFT', ($gallerySize - 100) / 2);//pixel the height of the wait msg
		$this->css->assign('BG_COLOR', $bgColor);
		$this->css->assign('COLOR_SELECTED', $this->getFFvalue('colorSelectedImg','sPref'));
		$this->css->parse('css');
	}

	/***********************************************************
	 * INIT THE THUMNAILS
	 ***********************************************************/
	function initThumbnailImage(&$images){
		//init some variables
		if($this->self->pi_getFFvalue($this->flexdata,'isFrame','sPref') == 1){
			$this->xtpl->assign('IS_FRAME','img-shadow');
		}
		$thumbnailSize = $this->self->pi_getFFvalue($this->flexdata,'thumbnailSize','sPref');
		$imageSize = $this->self->pi_getFFvalue($this->flexdata,'imageSize','sPref');

		//before looping do some things
		$index = 1;
		$this->xtpl->assign('CLASS_SELECTED','class="selected"'); // for the first image
		$originalImgs = 'new Array('; //for javascript
		$galleryImgs = 'new Array('; //for javascript

		foreach($images as $image){
			//Image
			unset($configImage); //reinit the array
			$configImage['file'] = $image['file_path'].$image['file_name'];
			$originalImgs .= '"'.$configImage['file'].'",';


			//SECURITY : CHECK IF THE FILE EXIST
			if(is_file($configImage['file']) && substr($image['file_name'],0,1) != '.'){ //handle hidden file
				//Thumbnail
				$configImage['file.']['height'] = $thumbnailSize; //resize the thumbnails
				$htmlThumbnail = $this->cObj->IMAGE($configImage);

				//add some attribute
				$conf['addParams.']['id'] = 'thumbNo'.$index;
				$htmlThumbnail = $this->cObj->stdWrap($htmlThumbnail, $conf);

				//reset a value from the conf array
				unset($configImage['file.']);
				//gallery image
				$fileInfo = getimagesize($configImage['file']);

				if($fileInfo[0] > $fileInfo[1]){ //width is bigger
					$configImage['file.']['width'] = $imageSize; //resize the picture
				}
				else{
					$configImage['file.']['height'] = $imageSize / $this->sizeDivisor; //resize the picture, a bit less
				}
				$htmlImage = $this->cObj->IMAGE($configImage);
				//parsing html
				$this->xtpl->assign('THUMBNAIL',$htmlThumbnail); //$div->debug($GLOBALS['TEMP_IMAGES_ON_PAGE']);
				$galleryImgs .= '"'.$this->_getImagePath($htmlImage).'",';

				$this->xtpl->assign('COUNTER_IMAGE',$index);
			}
			else{
				$this->data->deleteMedia($image['uid']);
				//delete hidden .file that are created by the OS for thumbnails
				if(is_file($configThumbnail['file']) && substr($image['file_name'],0,1) == '.' && mime_content_type($configThumbnail['file']) == 'image/jpeg'){
					unlink($configThumbnail['file']);
				}
				//some debug
				//echo ('PLUGIN ECO_GAL WARNING : no source image found in '.$configImage['file'].' for <b>content element '.$image['uid'].'</b> on page '.$this->cObj->data['pid']);
				//echo '<br>';
			}

			$this->xtpl->parse('viewPlayer.player.thumbnail');
			$this->xtpl->assign('CLASS_SELECTED','');
			$index ++;
		}

		//END... DO IT FOR THE LAST IMAGE
		unset($configImage);
		$configImage['file'] = t3lib_extMgm::siteRelPath('eco_gal').'ply1/img/end-'.$thumbnailSize.'.png';
		$htmlThumbnail = $this->cObj->IMAGE($configImage);
		//add some attribute
		$conf['addParams.']['id'] = 'thumbNo'.$index;
		$htmlThumbnail = $this->cObj->stdWrap($htmlThumbnail, $conf);
		$this->xtpl->assign('THUMBNAIL',$htmlThumbnail);
		$this->xtpl->assign('COUNTER_IMAGE',$index);
		$this->xtpl->parse('viewPlayer.player.thumbnail');
		$originalImgs = substr($originalImgs,0,strlen($originalImgs) -1);
		$originalImgs .= ')';
		$this->xtpl->assign('ORIGINAL_IMGS', $originalImgs);
		$galleryImgs .= "'/clear.gif')";
		$this->xtpl->assign('GALLERY_IMGS', $galleryImgs);
		$this->xtpl->parse('viewPlayer.player');
	}

	/***********************************************************
	 * INIT THE IMAGE CAPTION
	 ***********************************************************/
	function initCaptionImage($images){
		$loop = 1;
		foreach($images as $image){
			$this->xtpl->assign('CAPTION_TITLE', $this->_getTitle($image,$loop));
			$this->xtpl->assign('CAPTION_DESCRIPTION', $this->_getDescription($image));
			$this->xtpl->parse('viewPlayer.player.caption');
			$loop ++;
		}

		//END... last image
		$this->xtpl->assign('CAPTION_TITLE', '&nbsp;');
		$this->xtpl->assign('CAPTION_DESCRIPTION', '');
		$this->xtpl->parse('viewPlayer.player.caption');
	}
	/***********************************************************
	 * INIT THE FIRST IMAGE FROM THE GALLERY
	 ***********************************************************/
	function initFirstImage($image){
		//init some variables
		$imageSize = $this->self->pi_getFFvalue($this->flexdata,'imageSize','sPref');
		//processing ...
		$configImage['file'] = $image['file_path'].$image['file_name'];
		if(is_file($configImage['file']) && substr($image['file_name'],0,1) != '.'){ //handle hidden file
			$fileInfo = getimagesize($configImage['file']);
			if($fileInfo[0] > $fileInfo[1]){ //width is bigger
				$configImage['file.']['width'] = $imageSize;//resize the picture
			}
			else{
				$configImage['file.']['height'] = $imageSize / $this->sizeDivisor; //resize the picture, a bit less
			}
			$htmlImage = $this->cObj->IMAGE($configImage);
			//parsing html
			$this->xtpl->assign('PATH_IMAGE',$this->_getImagePath($htmlImage));
			$this->xtpl->assign('SRC_IMAGE', $configImage['file']);
			$this->xtpl->assign('CAPTION_TITLE', $this->_getTitle($image,1));
			$this->xtpl->assign('CAPTION_DESCRIPTION', $this->_getDescription($image));
		}
		else{ //handle the error
			$this->data->deleteMedia($image['uid']);
			//delete hidden .file mainly use for thumbnail
			if(is_file($configThumbnail['file']) && substr($image['file_name'],0,1) == '.'){
				unlink($configThumbnail['file']);
			}
			//die('PLUGIN ECO_GAL ERROR : no source image found in '.$configImage['file'].' for <b>content element '.$image['uid'].'</b> on page '.$this->cObj->data['pid']);
		}

	}

	/***********************************************************
	 * INIT THE ALBUM SELECT
	 ***********************************************************/
	function initAlbumSelect($titles,$selection){
		$max = $this->getFFvalue('limit','sPref');
		foreach ($titles as $uid => $title){
			$num = $this->sel->getCount($uid);
			if($num > $max && $max != 0){
				$num = $max;
			}

			$this->xtpl->assign('VALUE', $title.' ('.$num.')');
			$this->xtpl->assign('ID', $uid);

			$this->xtpl->assign('SELECTED', '');
			if($uid == $selection){
				$this->xtpl->assign('SELECTED', 'selected="selected"');
			}
			$this->xtpl->parse('viewPlayer.selectAlbum.optionAlbum');
		}
		$this->xtpl->parse('viewPlayer.selectAlbum');
	}

	/***********************************************************
	 * INIT THE SORT SELECT
	 ***********************************************************/
	function initSortSelect(){
		global $LANG;
		//an other possibility
		//$xml = file_get_contents(t3lib_extMgm::extPath('eco_gal').'locallang_db.xml');
		//$div = t3lib_div::makeInstance('t3lib_div');
		//$lang = $div->xml2array($xml);
		if(!$LANG->csConvObj){
			$LANG->csConvObj = t3lib_div::makeInstance('t3lib_cs');
		}

		//set utf-8
		if($lang != 'default') $LANG->csConvObj->charSetArray[$this->lang] = 'utf-8';

		$voc = t3lib_div::readLLfile(t3lib_extMgm::siteRelPath('eco_gal').'locallang_db.xml',$this->lang);

		$this->xtpl->assign('ASC_VALUE', $voc[$this->lang]['ply1.ascSort']);
		$this->xtpl->assign('DESC_VALUE', $voc[$this->lang]['ply1.descSort']);

		//reset this value to avoid conflict
		if($lang != 'default') $LANG->csConvObj->charSetArray[$this->lang] = '';

		if($this->self->pi_getFFvalue($this->flexdata,'defaultOrder','sPref') == 'ASC'){
			$this->xtpl->assign('ASC_SELECTED', 'selected="selected"');
		}
		else{
			$this->xtpl->assign('DESC_SELECTED', 'selected="selected"');
		}
		$this->xtpl->parse('viewPlayer.selectSort');
	}

	/***********************************************************
	 * RETURN THE VALUE OF THE ATTRIBUTE SRC FROM A IMG
	 ***********************************************************/
	function _getImagePath($htmlImage){
		$substr = substr($htmlImage, 10, 100);
		$stop = strpos($substr, '"');
		return substr($substr, 0, $stop);
	}

	/**
	 * Internal function extract and build the legend of the picture
	 */
	function _getTitle($image,$loop){
		$title = '';
		if($this->self->pi_getFFvalue($this->flexdata,'isNum','sPref') == '1'){
			if($this->self->pi_getFFvalue($this->flexdata,'isTitle','sPref') != '1' && $this->self->pi_getFFvalue($this->flexdata,'isDescription','sPref') != '1'){
				$title = '-'.$loop.'-'; //typography variant
			}
			else{
				$title = $loop.'. '; //typography variant
			}
		}
		if($this->self->pi_getFFvalue($this->flexdata,'isTitle','sPref') == '1'){
			$title .= $image['title'];
		}
		return htmlspecialchars($title);
	}

	/**
	 * Internal function extract and build the legend of the picture
	 */
	function _getDescription($image){
		$description = '';
		if($this->self->pi_getFFvalue($this->flexdata,'isDescription','sPref') == '1'){
			$description = htmlspecialchars($image['description']);
		}
		return $description;
	}

	/**
	 * extract a flexform's value from a specific sheet
	 */
	function getFFValue($field,$sheet){
		return $this->self->pi_getFFvalue($this->flexdata,$field,$sheet);
	}
}
?>
