<?php

/***************************************************************
 *	Copyright notice
 *
 *	(c) 2006 René Fritz <r.fritz at colorcube.de>
 *	(c) 2006 Fabien Udriot <fabien.udriot@ecodev.ch>
 *	All rights reserved
 *
 *	This script is part of the TYPO3 project. The TYPO3 project is
 *	free software; you can redistribute it and/or modify
 *	it under the terms of the GNU General Public License as published by
 *	the Free Software Foundation; either version 2 of the License, or
 *	(at your option) any later version.
 *
 *	The GNU General Public License can be found at
 *	http://www.gnu.org/copyleft/gpl.html.
 *
 *	This script is distributed in the hope that it will be useful,
 *	but WITHOUT ANY WARRANTY; without even the implied warranty of
 *	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.	See the
 *	GNU General Public License for more details.
 *
 *	This copyright notice MUST APPEAR in all copies of the script!
 ***************************************************************/

require_once(PATH_t3lib.'class.t3lib_treeview.php');

class tx_ecogal_tceFunc_selectTreeView extends t3lib_treeview {

	var $TCEforms_itemFormElName = '';
	var $TCEforms_nonSelectableItemsArray = array();



	function wrapTitle($title, $v){
		if($v['uid'] > 0) {
			if(in_array($v['uid'], $this->TCEforms_nonSelectableItemsArray))
				return '<a href="#" title="' . $v['description'] . '"><span style="color:#999;cursor:default;">' . $title . '</span></a>';
			else {
				$hrefTitle = $v['description'];
				$aOnClick = 'setFormValueFromBrowseWin(\'' . $this->TCEforms_itemFormElName . '\',' . $v['uid'] . ',\'' . t3lib_div::slashJS($title) . '\'); return false;';

				return '<a href="#" onclick="' . htmlspecialchars($aOnClick) . '" title="' . htmlentities($v['description']) . '">' . $title . '</a>';
			}
		}
		else
			return $title;
	}

}


class tx_ecogal_treeview {

	function displayCategoryTree($PA, $fobj)    {
		$table = $PA['table'];
		$field = $PA['field'];
		$row = $PA['row'];
		
		$this->pObj = &$PA['pObj'];

		$config = $PA['fieldConf']['config'];
		$config['maxitems'] = ($config['maxitems']==2) ? 1 : $config['maxitems'];

		$selItems = $this->pObj->addSelectOptionsToItemArray($this->pObj->initItemArray($PA['fieldConf']), $PA['fieldConf'], $this->pObj->setTSconfig($table, $row), $field);


		$maxitems = intval($config['maxitems']);
		$minitems = intval($config['minitems']);
		$size = intval($config['size']);


		if((bool)$maxitems && (bool)$config['treeView']) {
			$item .= '<input type="hidden" name="' . $PA['itemFormElName'] . '_mul" value="' . (bool)$config['multiple'] . '" />';

			$maxitems = (bool)$maxitems ? 1000 : t3lib_div::intInRange($config['maxitems'], 0);
			$minitems = t3lib_div::intInRange($config['minitems'], 0);

			$this->pObj->requiredElements[$PA['itemFormElName']] = array($minitems, $maxitems, 'imgName' => $table . '_' . $row['uid'] . '_' . $field);


			if((bool)$config['treeView'] && $config['foreign_table']) {
				global $TCA, $LANG;

				
				$damSource = $GLOBALS['TYPO3_DB']->exec_SELECTgetRows('uid','pages',"module='dam'");
				
				$TSconfig = t3lib_BEfunc::getTCEFORM_TSconfig($table, $row);
				$SPaddWhere = ' AND tx_dam_selection.pid IN (\'' . $damSource[0]['uid'] . '\')';


				if(!is_object($treeViewObj = &t3lib_div::getUserObj($config['treeViewClass'], 'user_', true)))
					$treeViewObj = t3lib_div::makeInstance('tx_ecogal_tceFunc_selectTreeView');
					
				$treeViewObj->table = $config['foreign_table'];
				$treeViewObj->init($SPaddWhere, 'uid');
				$treeViewObj->backPath = $this->pObj->backPath;
				$treeViewObj->parentField = 0;
				$treeViewObj->expandAll = 1;
				$treeViewObj->expandFirst = 1;
				$treeViewObj->fieldArray = array('uid', 'title');
				$treeViewObj->ext_IconMode = 1;
				$treeViewObj->title = $LANG->sL($TCA[$config['foreign_table']]['ctrl']['title']);

				$treeViewObj->TCEforms_itemFormElName = $PA['itemFormElName'];
				if($table == $config['foreign_table'])
					$treeViewObj->TCEforms_nonSelectableItemsArray[] = $row['uid'];

				$treeContent = $treeViewObj->getBrowsableTree();
				$treeItemC = count($treeViewObj->ids);

				$width = 250;
				if($GLOBALS['CLIENT']['BROWSER'] == 'msie')
					$width = 320;

				$config['autoSizeMax'] = t3lib_div::intInRange($config['autoSizeMax'], 0);
				$height = $config['autoSizeMax'] ? t3lib_div::intInRange($treeItemC + 2, t3lib_div::intInRange($size, 1), $config['autoSizeMax']) : $size;
				$height = $height * 26;
				$divStyle = 'position: relative; left: 0px; top: 0px; height: ' . $height . 'px; width: '. $width . 'px; border: solid 1px; overflow: auto; background: #fff;';
				$thumbnails = '<div  name="' . $PA['itemFormElName'].'_selTree" style="' . htmlspecialchars($divStyle) . '">' . $treeContent . '</div>';
			}


			$nMV_label = isset($PA['fieldTSConfig']['noMatchingValue_label']) ? $this->pObj->sL($PA['fieldTSConfig']['noMatchingValue_label']) : '[ ' . $this->pObj->getLL('l_noMatchingValue') . ' ]';

			$itemArray = t3lib_div::trimExplode(',', $PA['itemFormElValue'], 1);
			foreach($itemArray as $tk => $tv) {
				$tvP = explode('|', $tv, 2);
				$evalValue = rawurldecode($tvP[0]);

				if($this->isValueValid($evalValue, $treeViewObj->ids))
					$tvP[1] = rawurldecode($tvP[1]);
				else
					$tvP[1] = @sprintf($nMV_label, $tvP[1]);

				$itemArray[$tk] = implode('|', $tvP);
			}

			$sWidth = 250;
			$params = array(
				'size' => $size,
				'autoSizeMax' => t3lib_div::intInRange($config['autoSizeMax'],0),
				'style' => ' style="width: ' . $sWidth . 'px;"',
				'dontShowMoveIcons' => ($maxitems <= 1),
				'maxitems' => $maxitems,
				'info' => '',
				'headers' => array(
					'selector' => $this->pObj->getLL('l_selected') . ':<br />',
					'items' => $this->pObj->getLL('l_items') . ':<br />'
				),
				'noBrowser' => 1,
				'thumbnails' => $thumbnails
			);

			$item .= $this->pObj->dbFileIcons($PA['itemFormElName'], '', '', $itemArray, '', $params, $PA['onFocus']);

			$altItem = '<input type="hidden" name="' . $PA['itemFormElName'] . '" value="' . htmlspecialchars($PA['itemFormElValue']) . '" />';
			$item = $this->pObj->renderWizards(array($item, $altItem), $config['wizards'], $table, $row, $field, $PA, $PA['itemFormElName'], array());

		}

		return $this->NA_Items . $item;

	}


	function isValueValid($evalValue, $itemArr) {
		return in_array($evalValue, $itemArr);
	}

}


if (defined('TYPO3_MODE') && $TYPO3_CONF_VARS['TYPO3_MODE']['XCLASS']['ext/tt_news/class.tx_ttnews_treeview.php'])    {
    include_once($TYPO3_CONF_VARS['TYPO3_MODE']['XCLASS']['ext/tt_news/class.tx_ttnews_treeview.php']);
}
?>
